<?php

if (!defined('IN_ECS'))
{
    die('Hacking attempt');
}

$shipping_lang = ROOT_PATH.'languages/' .$GLOBALS['_CFG']['lang']. '/shipping/smilepay_c2cup.php';
if (file_exists($shipping_lang))
{
    global $_LANG;
    include_once($shipping_lang);
 
}

/* 模块的基本信息 */
if (isset($set_modules) && $set_modules == TRUE)
{
    $i = (isset($modules)) ? count($modules) : 0;

    /* 配送方式插件的代码必须和文件名保持一致 */
    $modules[$i]['code']    = basename(__FILE__, '.php');

    $modules[$i]['version'] = '2.2.0';
   
    /* 配送方式的描述 */
    $modules[$i]['desc']    = 'smilepay_c2cup_desc';
 //   $url= $GLOBALS['ecs']->url()."smilepay_c2c_recv.php?action=emapreturn";
   //  $_LANG['smilepay_c2cup_desc'] .= "<a href='http://emap.shopping7.com.tw/emap/emapu8.ashx?eshopid=870&servicetype=1&url=$url'>選擇電子地圖</a>";
    /* 配送方式是否支持货到付款 */
    $modules[$i]['cod']     = FALSE;

    /* 插件的作者 */
    $modules[$i]['author']  = '訊航科技';

    /* 插件作者的官方网站 */
    $modules[$i]['website'] = 'http://www.smilepay.net/';

    /* 配送接口需要的参数 */
    $modules[$i]['configure'] = array(
                                    array('name' => 'base_fee', 'value' => 0),
                                    array('name'=>'smilepay_c2cup_account','type'=>'text','value'=>''),
                                    array('name'=>'smilepay_c2cup_rvg2c','type'=>'text','value'=>''),
                                    array('name'=>'smilepay_c2cup_verifykey','type'=>'text','value'=>''),
                                );

    /* 模式编辑器 */
    $modules[$i]['print_model'] = 2;

    /* 打印单背景 */
    $modules[$i]['print_bg'] = '';

   /* 打印快递单标签位置信息 */
    $modules[$i]['config_lable'] = '';

    return;
}

class smilepay_c2cup
{
    /*------------------------------------------------------ */
    //-- PUBLIC ATTRIBUTEs
    /*------------------------------------------------------ */

    /**
     * 配置信息
     */
    var $configure;
    protected $c2c_code = 'c2cup';
    /*------------------------------------------------------ */
    //-- PUBLIC METHODs
    /*------------------------------------------------------ */

    /**
     * 构造函数
     *
     * @param: $configure[array]    配送方式的参数的数组
     *
     * @return null
     */
    function smilepay_c2cup($cfg = array())
    {
        /*if(empty($cfg))
        {
            $sql = 'SELECT configure FROM ' . $GLOBALS['ecs']->table('shipping_area'). " WHERE shipping_id  in (". 'SELECT shipping_id FROM ' . $GLOBALS['ecs']->table('shipping'). " WHERE shipping_code = 'smilepay_c2cup')";
            $data=$GLOBALS['db']->getOne($sql); 
            $cfg=unserialize($data);
        }*/

        foreach ($cfg AS $key => $val)
        {
            $this->configure[$val['name']] = $val['value'];
        }

    }

    /**
     * 计算订单的配送费用的函数
     *
     * @param   float   $goods_weight   商品重量
     * @param   float   $goods_amount   商品金额
     * @return  decimal
     */
    function calculate($goods_weight, $goods_amount)
    {
        if ($this->configure['free_money'] > 0 && $goods_amount >= $this->configure['free_money'])
        {
            return 0;
        }
        else
        {
            return isset($this->configure['base_fee']) ? $this->configure['base_fee'] : 0;
        }
    }

    /**
     * 查询发货状态
     * 该配送方式不支持查询发货状态
     *
     * @access  public
     * @param   string  $invoice_sn     发货单号
     * @return  string
     */
    function query($invoice_sn)
    {
        return $invoice_sn;
    }
    function get_emap_url()
    {
        $url= $GLOBALS['ecs']->url()."smilepay_c2c_recv.php";
        $params="action=emapreturn|type=$this->c2c_code";
        return "https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&tempvar=$params&url=$url";
    }
 

    protected function init_config_by_order_id($order_id)
    {
        $order=order_info($order_id);
        //shipping data
        $sql = 'SELECT shipping_area_id,configure FROM ' . $GLOBALS['ecs']->table('shipping_area'). " WHERE shipping_id  in (". 'SELECT shipping_id FROM ' . $GLOBALS['ecs']->table('shipping'). " WHERE shipping_code = 'smilepay_c2cup')";
        $data=$GLOBALS['db']->getAll($sql); 

        //region
        $sql = 'SELECT * FROM ' . $GLOBALS['ecs']->table('area_region');
        $regions=$GLOBALS['db']->getAll($sql); 
                  

        foreach($data as $tmp)
        {
            //find region
            foreach( $regions as $region)
            {
                if( $region['shipping_area_id'] == $tmp['shipping_area_id'])
                {
                    
                    if($region['region_id'] == $order['country'] 
                        || $region['region_id'] == $order['province'] 
                        || $region['region_id'] == $order['city'] 
                        || $region['region_id'] == $order['district'] 
                    )
                    {


                        $this->smilepay_c2cup(unserialize( $tmp['configure']));
                        return true;
                    }
                }
            }

        }
        return flase;
       
    }

    function set_emap_data($data)
    {
       $_SESSION['smilepay_c2cup_data']['address'] = $data['address'];
       $_SESSION['smilepay_c2cup_data']['storeid'] = $data['storeid'];
       $_SESSION['smilepay_c2cup_data']['storename'] = $data['storename'];
       $_SESSION['smilepay_c2cup_data']['type'] = $data['type'];
    }
    function get_storename()
    {
       if(!isset($_SESSION['smilepay_c2cup_data']['type']) || $_SESSION['smilepay_c2cup_data']['type']!=$this->c2c_code) //type_error
       {
           return false;
       }
       return isset($_SESSION['smilepay_c2cup_data']['storename']) ? $_SESSION['smilepay_c2cup_data']['storename'] : false;
    }
    function is_emap_selected()
    {
       if(!isset($_SESSION['smilepay_c2cup_data']['type']) || $_SESSION['smilepay_c2cup_data']['type']!=$this->c2c_code) //type_error
       {
           return false;
       }

       if(!isset(  $_SESSION['smilepay_c2cup_data']['address']) || !isset($_SESSION['smilepay_c2cup_data']['storeid']) || !isset( $_SESSION['smilepay_c2cup_data']['storename'])
            || empty(  $_SESSION['smilepay_c2cup_data']['address']) || empty($_SESSION['smilepay_c2cup_data']['storeid']) || empty( $_SESSION['smilepay_c2cup_data']['storename']))
       {
            return false;
       }
       return true;
    }

    function validateparam()
    {
        $result = array();
        
        if(mb_strlen($_SESSION['flow_order']['consignee'],'utf-8')>5)
           $result['error']=$GLOBALS['_LANG']['smilepay_c2cup_error_name']; 
        elseif (!preg_match("/^[0][9][0-9]{8,8}$/",$_SESSION['flow_order']['mobile']))  // phone rule
           $result['error']=$GLOBALS['_LANG']['smilepay_c2cup_error_phone']; 
        return $result;
    }
    protected function cleardata()
    {
        unset( $_SESSION['smilepay_c2cup_data']);
    }

    function run_order_place($order_id=0,$order_sn=0,$clearflag=true)
    {
        include_once(ROOT_PATH . 'includes/init.php');
        $result=array();
        if($order_id==0 && $order_sn==0)
        {
            $result['Status'] = 0xf0001;
            $result['Desc'] = '錯誤訂單編號';
            return  $result;
        }
        $order=order_info($order_id,$order_sn);
        if(!isset($order)&&empty($order))
        {
            $result['Status'] = 0xf0001;
            $result['Desc'] = '取得訂單錯誤，訂單編號:'.$order_id." & " . $order_sn;
            return  $result;
        }
        //get and set configure
        $this->init_config_by_order_id($order['order_id']);

        /*include_once(ROOT_PATH.'debugfun.php');
            $filelog=new DebugFile('C:/mytestlog/ecsshipping_config.txt');
    $filelog->writeline(print_r( $order,true)); 
    */
        //set connect param
        $data['Mobile_number']=  $order['mobile'];
        $data['Logistics_store'] = $_SESSION['smilepay_c2cup_data']['storeid']. "/" .$_SESSION['smilepay_c2cup_data']['storename']."/". $_SESSION['smilepay_c2cup_data']['address'];
        
        $data['Od_sob'] =   $order['order_sn'];	      		    
        $data['Dcvc']    =$this->configure['smilepay_c2cup_account']; 
        $data['Rvg2c']   =$this->configure['smilepay_c2cup_rvg2c'];
   	    $data['Pay_zg']    = '52';//付款方式
        $data['Data_id']   = $order['order_sn']; //賣家自訂交易編號    			
		$data['Pur_name']  =  mb_substr($order['consignee'],0,5,"utf-8");    
   	    $data['Email']     =  $order['email'];
        $data['Address']   =  '';		
		$data['Tel_number']   =  $order['tel'];			                                     		
        $data['Verify_key']= $this->configure['smilepay_c2cup_verifykey'];
        //$data['Roturl_status']= "ecsok";            
        $data['Pay_gdry']= 'TW';
        
      //  if($order['pay_status'] == PS_PAYED) // paid or not	 
        $data['Amount'] = intval(round($order['money_paid'])) +intval(round($order['order_amount'])) ;
       // else
         // $data['Amount'] =intval(round($order['order_amount']));  

        if($this->is_emap_selected())
        {
            //connect
             $ch = curl_init();
             curl_setopt($ch, CURLOPT_URL,'http://ssl.smse.com.tw/api/sppayment.asp');
             curl_setopt($ch, CURLOPT_VERBOSE, 1);
             curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
             curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
             curl_setopt($ch, CURLOPT_POST, 1);
             curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
             curl_setopt($ch,CURLOPT_POSTFIELDS,    http_build_query( $data));
        
             $strAuth= curl_exec($ch);


                              
             if (curl_errno($ch)) {
                $strAuth = false;
             }
             curl_close($ch);
             if(isset($strAuth)) {
      	        // 分解字串
      	        
        		    $xml = simplexml_load_string($strAuth);

      			    $Status = $xml->Status;
      			
                    if ($Status=="1") {
            
                        (strlen($xml->PayEndDate) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                     
                        $params = array(
                                    'PayEndDate' =>urlencode($xmlPayEndDate),
                                    'Amount' => strval($xml->Amount),
                                    'Data_id' => strval($xml->Data_id),
                                    'Status' =>strval($xml->Status),
                                    'SmilePayNO' => strval($xml->SmilePayNO),
                                    'address' =>    $_SESSION['smilepay_c2cup_data']['address'],
                                    'storeid' =>  $_SESSION['smilepay_c2cup_data']['storeid'] ,
                                    'storename' =>  $_SESSION['smilepay_c2cup_data']['storename'], 
                                    'name' => $data['Pur_name'],
                                    'mobile' => $data['Mobile_number'],
                                    );   
                    
                    }else{    
                        $params = array(
                            'Status'=>strval($xml->Status),
                            'Desc'=>strval($xml->Desc),
                            'Data_id'=>strval($xml->Data_id),
                         );   
                    } 
                 } else {
                    $params = array(
                            'Status'=>'-1000',
                            'Desc'=>'取號失敗',    
                            'Data_id'=> $order['order_sn'],
                            );     
                  }
                  if($params['Status']==1)
                  {
                      //link comment
                      $admincomment=$GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_print_note_format'];
                      order_action($order['order_sn'], $order['order_status'] ,  $order['shipping_status'],  $order['pay_status'], $admincomment, $GLOBALS['_LANG']['buyer']);
                      $admincomment=sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_print_format'],$params['SmilePayNO'],$data['Dcvc'],$data['Verify_key']);
                      order_action($order['order_sn'], $order['order_status'] ,  $order['shipping_status'],  $order['pay_status'], $admincomment, $GLOBALS['_LANG']['buyer']);
                      //msg comment
                      $admincomment =sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_format'],$params['SmilePayNO'], $params['name'],$params['mobile'],$params['storename'],$params['storeid'],$params['address']);
                      $customercomment =sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_customer_format'], $params['name'],$params['mobile'],$params['storename'],$params['storeid'],$params['address']);
                      $customercommenttobuyer = $order['to_buyer'] .$customercomment;
                  }
                  else
                  {
                      $admincomment =sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_error_format'],$params['Status'], $params['Desc']);
                      $customercomment =sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_customer_error_format']);
                      $customercommenttobuyer = $order['to_buyer'] .$customercomment;
                  }
                  
                  
                  update_order($order['order_id'], array('confirm_time' => gmtime(),'to_buyer'=>$customercommenttobuyer));

                  order_action($order['order_sn'], $order['order_status'] ,  $order['shipping_status'],  $order['pay_status'], $admincomment, $GLOBALS['_LANG']['buyer']);
        }
        else
        {
            $admincomment =sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_error_emap_data']);
            $customercomment =sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_commnet_error_emap_data']);
            $customercommenttobuyer = $order['to_buyer'] .$customercomment;
            update_order($order['order_id'], array('confirm_time' => gmtime(),'to_buyer'=>$customercommenttobuyer));
            order_action($order['order_sn'], $order['order_status'] ,  $order['shipping_status'],  $order['pay_status'], $admincomment, $GLOBALS['_LANG']['buyer']);
        }


        if($clearflag)
        {
            $this->cleardata();
        }
        return  $params;

       
    }
    function run_order_place_and_get_content($order_id=0,$order_sn=0,$clearflag=true)
    {
        $result= $this->run_order_place($order_id,$order_sn,$clearflag);
        if( $result['Status']==1)
        {
            $smilepay_content=sprintf($GLOBALS['_LANG']['smilepay_c2cup_order_result_format'],$result['name'],$result['mobile'],$result['storename'],$result['storeid'],$result['address']);
        }
        else
        {
            $smilepay_content=$GLOBALS['_LANG']['smilepay_c2cup_order_result_error_format'];
        }
        

        return $smilepay_content;
    }
    function getConfigCode()
    {
        return $this->c2c_code;
    }


}



?>
